# -*- coding: utf-8 -*-
import json


from entity.OrderInfo import OrderInfo,Contact,Passengers,Segments
from utils.CallbackOrderUtils import CallbackOrderUtils as call
from query.AkWebQuery import AkWebQuery
from query.AkBigQuery import AkBigQuery

orderJson = '{"account":{"passWord":"Tripto123","userName":"CNTRIPTOPK_ADMIN"},"adultNum":1,"childNum":0,"cid":"2018031210044435332153819","contactEntity":{"email":"laopengxg@sina.com","firstName":"xiufan","gender":"M","lastName":"zhan","mobile":"13691541121"},"data":{"accountCode":"1001"},"formCity":"DMK","fromDate":"2018-03-29","fromPrice":136,"fromSegments":[{"aircraftCode":"空客320(中)","arrAirport":"HKT","arrTime":"201803292245","cabin":"E","carrier":"FD","codeshare":false,"depAirport":"DMK","depTime":"201803292125","flightNumber":"FD3015","stopCities":""}],"passengersEntities":[{"ageType":0,"birthday":"1985-03-08","cardExpired":"20200306","cardIssuePlace":"CN","cardNum":"E54673577","cardType":"PP","firstName":"NA","gender":"F","lastName":"LI","nationality":"CN"}],"retSegments":[],"toCity":"HKT","tripType":1}'
json_str = json.loads(orderJson)

#获取订单信息
oinfo = OrderInfo()
oinfo.cid =json_str['cid']             #CID 唯一标识
oinfo.tripType =json_str['tripType']   #行程类型 1.单程 2.往返
oinfo.formCity =json_str['formCity']   #去程三字码
oinfo.fromDate =json_str['fromDate']   #去程日期 2018-04-20
oinfo.fromPrice =json_str['fromPrice'] #去程单价
oinfo.toCity =json_str['toCity']       #到达三字码
if oinfo.tripType == 2:
    oinfo.retDate =json_str['retDate']     #返程日期 2018-04-29
oinfo.adultNum =json_str['adultNum']   #成人乘客数
oinfo.childNum =json_str['childNum']   #儿童乘客数

#获取联系人信息
contact = Contact()
contact.firstname = json_str['contactEntity']['firstName'] #名
contact.lastname = json_str['contactEntity']['lastName']   #姓
contact.mobile = json_str['contactEntity']['mobile']       #手机号
contact.email = json_str['contactEntity']['email']         #邮箱
contact.gender = json_str['contactEntity']['gender']       #性别，M 男，F 女

#获取乘机人信息
passengersList = []
passJsonArray = json_str['passengersEntities']
for kpa in passJsonArray:
    passObj = Passengers()
    passObj.ageType = kpa['ageType']        #乘客类型  0-成人，1-儿童，2-留学生
    passObj.firstname = kpa['firstName']    #名
    passObj.lastname = kpa['lastName']      #姓
    passObj.birthday = kpa['birthday']      #生日  格式为yyyy-MM-dd
    passObj.gender = kpa['gender']          #性别，M 男，F 女
    passObj.cardType = kpa['cardType']      #证件类型 PP.护照 GA.港澳通行证 TW.台湾通行证 TB.台胞证 HX.回乡证  HY.国际海员证
    passObj.cardNum = kpa['cardNum']        #证件号码
    passObj.nationality = kpa['nationality']#国籍
    passengersList.append(passObj)
    
#去程航段
fromSegments = []
fromSegmentsArray = json_str['fromSegments']
fromFlight = ''
for kfsa in fromSegmentsArray:
    seg = Segments()
    seg.carrier = kfsa['carrier']       #航司IATA二字码 AK
    seg.flightNumber = kfsa['flightNumber']  #航班号 ZQ555
    seg.aircraftCode = kfsa['aircraftCode']  #机型  空客A380
    seg.cabin = kfsa['cabin']         #舱位等级 EC.特惠 EP.低航费 VF.超值套餐 HF.常飞客 PM.豪华平躺
    seg.depAirport = kfsa['depAirport']    #出发机场IATA三字码   KUL
    seg.arrAirport = kfsa['arrAirport']    #到达机场IATA三字码   DPS
    seg.arrTime = kfsa['arrTime']       #起飞时间20180428053
    seg.depTime = kfsa['depTime']       #到达时间 20180428013
    seg.codeshare = kfsa['stopCities']     #代码共享标识（true代码共享/false非代码共享）
    fromFlight += seg.flightNumber+','
    fromSegments.append(seg)
oinfo.fromFlight = fromFlight
oinfo.fromSegments = fromSegments
#返程航段
if oinfo.tripType == 2:
    retSegments = []
    retSegmentsArray = json_str['retSegments']
    retFlight = ''
    for kfsa in fromSegmentsArray:
        seg = Segments()
        seg.carrier = kfsa['carrier']       #航司IATA二字码 AK
        seg.flightNumber = kfsa['flightNumber']  #航班号 ZQ555
        seg.aircraftCode = kfsa['aircraftCode']  #机型  空客A380
        seg.cabin = kfsa['cabin']         #舱位等级 EC.特惠 EP.低航费 VF.超值套餐 HF.常飞客 PM.豪华平躺
        seg.depAirport = kfsa['depAirport']    #出发机场IATA三字码   KUL
        seg.arrAirport = kfsa['arrAirport']    #到达机场IATA三字码   DPS
        seg.arrTime = kfsa['arrTime']       #起飞时间20180428053
        seg.depTime = kfsa['depTime']       #到达时间 20180428013
        seg.codeshare = kfsa['stopCities']     #代码共享标识（true代码共享/false非代码共享）
        retFlight += seg.flightNumber+','
        fromSegments.append(seg)
    oinfo.retFlight = retFlight
    oinfo.retSegments = retSegments
print('数据解析完毕，现在可以输出数据了')       
print(oinfo.fromFlight)
print(oinfo.retFlight)
print(oinfo.formCity)
print(oinfo.toCity)
print(oinfo.fromDate)
print(oinfo.retDate)

#调用货币查询结果
stationCode = oinfo.formCity
cl = call()
currency = cl.cityToCurrency(oinfo.formCity)
oinfo.currency = currency
oinfo.fxRate = currency.AkOriginRate
oinfo.currencyCode = currency.currencyCode
print(oinfo.fxRate)
print(oinfo.currencyCode)

print('---------------------接下来调用查询---------------------')
#查询字符串JSON
queryInputJson = {
    "adultNum": oinfo.adultNum,
    "childNum": oinfo.childNum,
    "formCity": oinfo.formCity,
    "fromDate": oinfo.fromDate,
    "id": 0,
    "retDate": oinfo.retDate,
    "toCity": oinfo.toCity,
    "tripType": oinfo.tripType,
    "uuid": "AKBigWeb",
    "currency": oinfo.currencyCode
}
#发起Web查询
akwebQuer = AkWebQuery(queryInputJson,oinfo.tripType,oinfo.fromFlight,oinfo.retFlight)
akQueryWebFrom,akQueryWebRet = akwebQuer.StartQuery()
print('Web去程：'+akQueryWebFrom)
print('Web返程：'+akQueryWebRet)
oinfo.webIsOk = True
oinfo.webFromJson = akQueryWebFrom
oinfo.webRetJson = akQueryWebRet
#发起Big查询
akbigQuer = AkBigQuery(queryInputJson,oinfo.tripType,oinfo.fromFlight,oinfo.retFlight)
akQueryBigFrom,akQueryBigRet = akbigQuer.StartQuery()
print('Big去程：'+akQueryBigFrom)
print('Big返程：'+akQueryBigRet)
oinfo.bigIsOk = True
oinfo.bigFromJson = akQueryBigFrom
oinfo.bigRetJson = akQueryBigRet

print('----------------------------Web is Big Query OK---------------------')

#接下来进行比价  组装，下单数据
#8888888

